from Exceptions import *
from SeqServices import *

class CurveT:

  MAX_ORDER = 2
  DX = 1E-3

  def __init__(self, X, Y, i):
    if not isAscending(X):
      raise IndepVarNotAscending
    if i < 1 or i > CurveT.MAX_ORDER:
      raise InvalidInterpOrder
      
    self.__minx = X[0] 
    self.__maxx = X[-1]
    self.__o = i
    
    self.X = X
    self.Y = Y
  
  
  def minD(self):
    return self.__minx
  
  
  def maxD(self):
    return self.__maxx
    
  
  def order(self):
    return self.__o
  
  
  def eval(self, x):
    if x < self.__minx or x > self.__maxx:
      raise OutOfDomain
    if self.__o == 1:
      return (lambda v: interpLin(self.X[index(self.X, v)], self.Y[index(self.X, v)], self.X[index(self.X, v) + 1], self.Y[index(self.X, v) + 1], v))(x)
    elif self.__o == 2:
      return (lambda v: interpQuad(self.X[index(self.X, v) - 1], self.Y[index(self.X, v) - 1], self.X[index(X, v)], self.Y[index(self.X, v)], self.X[index(self.X, v) + 1], self.Y[index(self.X, v) + 1], v))(x)

  def dfdx(self, x):
    if x < self.__minx or x > self.__maxx:
      raise OutOfDomain
    return self.__f(x + DX) - self.__f(x) / DX

  def d2fdx2(self, x):
    if x < self.__minx or x > self.__maxx:
      raise OutOfDomain
    return self.__f(x + 2*DX) - 2*self.__f(x + DX) + self.__f(x) / DX**2
